#include "metalShaderTypes.h"
#include "alpha.h"

typedef struct
{
    float numOfColors;
    float gammaValue;
} fxVars;


vertex fxVertexOut vertexFunc(uint vertexID [[ vertex_id ]]
                              ,const device fxShaderVerts* in[[ buffer(0) ]]
                              ,texture2d<half> inputTex0 [[ texture(0) ]]
                              ,texture2d<half> inputTexMask [[ texture(1) ]]
                              ,constant fxGeneralUniforms& u[[ buffer(1) ]]
                              ,constant fxVars& vars[[ buffer(2)]])
{
    fxVertexOut out;

    out.normPos=in[vertexID].pos.xy*vec2(.5,.5f)+vec2(.5,.5);
    out.position=in[vertexID].pos;

    out.tex1=in[vertexID].tex1;
    out.texMask=in[vertexID].texMask;
    out.texSize=float2(inputTex0.get_width(),inputTex0.get_height());
    return out;
}

fragment float4 fragmentFunc(fxVertexOut input [[stage_in]]
                             ,texture2d<half> inputTex [[ texture(0) ]]
                             ,texture2d<half> inputTexMask [[ texture(1) ]]
                             ,constant fxGeneralUniforms& u[[ buffer(0) ]]
                             ,constant fxVars& vars[[ buffer(1)]])
{

    vec4 texColor = getColor(inputTex, fsTexture);
#ifdef PRE_MULT
    divideAlpha(texColor);
#endif
    float4 outColor=texColor;
    outColor.rgb /= u.nitsScale;
    outColor.rgb = pow(outColor.rgb, vec3(vars.gammaValue));
    outColor.rgb = outColor.rgb * float(vars.numOfColors);
    outColor.rgb = floor(outColor.rgb);
    outColor.rgb = outColor.rgb /  float(vars.numOfColors);
    outColor.rgb = pow(outColor.rgb, vec3(1.0/vars.gammaValue));
    outColor.rgb *= u.nitsScale;


    float blendValue=u.blendValue;
#ifdef USE_MASK
    blendValue*=getColor(inputTexMask,input.texMask).a;
#endif
    outColor.rgb=mix(texColor.rgb,outColor.rgb,blendValue);
    outColor.a=texColor.a;
#ifdef PRE_MULT
    multiplyAlpha(outColor);
#endif
    return outColor;
}
